package com.chinaitop.depot.intelligent.energyMonitor.model;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class TEnergyHistoryExample {
    /**
     * t_energy_history
     */
    protected String orderByClause;

    /**
     * t_energy_history
     */
    protected boolean distinct;

    /**
     * t_energy_history
     */
    protected List<Criteria> oredCriteria;

    public TEnergyHistoryExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * t_energy_history 2019-03-12
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andIdIsNull() {
            addCriterion("id is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("id is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("id =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("id <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("id >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("id >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("id <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("id <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("id like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("id not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("id in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("id not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("id between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("id not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNull() {
            addCriterion("org_id is null");
            return (Criteria) this;
        }

        public Criteria andOrgIdIsNotNull() {
            addCriterion("org_id is not null");
            return (Criteria) this;
        }

        public Criteria andOrgIdEqualTo(String value) {
            addCriterion("org_id =", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotEqualTo(String value) {
            addCriterion("org_id <>", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThan(String value) {
            addCriterion("org_id >", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdGreaterThanOrEqualTo(String value) {
            addCriterion("org_id >=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThan(String value) {
            addCriterion("org_id <", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLessThanOrEqualTo(String value) {
            addCriterion("org_id <=", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdLike(String value) {
            addCriterion("org_id like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotLike(String value) {
            addCriterion("org_id not like", value, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdIn(List<String> values) {
            addCriterion("org_id in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotIn(List<String> values) {
            addCriterion("org_id not in", values, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdBetween(String value1, String value2) {
            addCriterion("org_id between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andOrgIdNotBetween(String value1, String value2) {
            addCriterion("org_id not between", value1, value2, "orgId");
            return (Criteria) this;
        }

        public Criteria andVNhCodeIsNull() {
            addCriterion("v_nh_code is null");
            return (Criteria) this;
        }

        public Criteria andVNhCodeIsNotNull() {
            addCriterion("v_nh_code is not null");
            return (Criteria) this;
        }

        public Criteria andVNhCodeEqualTo(String value) {
            addCriterion("v_nh_code =", value, "vNhCode");
            return (Criteria) this;
        }

        public Criteria andVNhCodeNotEqualTo(String value) {
            addCriterion("v_nh_code <>", value, "vNhCode");
            return (Criteria) this;
        }

        public Criteria andVNhCodeGreaterThan(String value) {
            addCriterion("v_nh_code >", value, "vNhCode");
            return (Criteria) this;
        }

        public Criteria andVNhCodeGreaterThanOrEqualTo(String value) {
            addCriterion("v_nh_code >=", value, "vNhCode");
            return (Criteria) this;
        }

        public Criteria andVNhCodeLessThan(String value) {
            addCriterion("v_nh_code <", value, "vNhCode");
            return (Criteria) this;
        }

        public Criteria andVNhCodeLessThanOrEqualTo(String value) {
            addCriterion("v_nh_code <=", value, "vNhCode");
            return (Criteria) this;
        }

        public Criteria andVNhCodeLike(String value) {
            addCriterion("v_nh_code like", value, "vNhCode");
            return (Criteria) this;
        }

        public Criteria andVNhCodeNotLike(String value) {
            addCriterion("v_nh_code not like", value, "vNhCode");
            return (Criteria) this;
        }

        public Criteria andVNhCodeIn(List<String> values) {
            addCriterion("v_nh_code in", values, "vNhCode");
            return (Criteria) this;
        }

        public Criteria andVNhCodeNotIn(List<String> values) {
            addCriterion("v_nh_code not in", values, "vNhCode");
            return (Criteria) this;
        }

        public Criteria andVNhCodeBetween(String value1, String value2) {
            addCriterion("v_nh_code between", value1, value2, "vNhCode");
            return (Criteria) this;
        }

        public Criteria andVNhCodeNotBetween(String value1, String value2) {
            addCriterion("v_nh_code not between", value1, value2, "vNhCode");
            return (Criteria) this;
        }

        public Criteria andFTotalNhIsNull() {
            addCriterion("f_total_nh is null");
            return (Criteria) this;
        }

        public Criteria andFTotalNhIsNotNull() {
            addCriterion("f_total_nh is not null");
            return (Criteria) this;
        }

        public Criteria andFTotalNhEqualTo(BigDecimal value) {
            addCriterion("f_total_nh =", value, "fTotalNh");
            return (Criteria) this;
        }

        public Criteria andFTotalNhNotEqualTo(BigDecimal value) {
            addCriterion("f_total_nh <>", value, "fTotalNh");
            return (Criteria) this;
        }

        public Criteria andFTotalNhGreaterThan(BigDecimal value) {
            addCriterion("f_total_nh >", value, "fTotalNh");
            return (Criteria) this;
        }

        public Criteria andFTotalNhGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("f_total_nh >=", value, "fTotalNh");
            return (Criteria) this;
        }

        public Criteria andFTotalNhLessThan(BigDecimal value) {
            addCriterion("f_total_nh <", value, "fTotalNh");
            return (Criteria) this;
        }

        public Criteria andFTotalNhLessThanOrEqualTo(BigDecimal value) {
            addCriterion("f_total_nh <=", value, "fTotalNh");
            return (Criteria) this;
        }

        public Criteria andFTotalNhIn(List<BigDecimal> values) {
            addCriterion("f_total_nh in", values, "fTotalNh");
            return (Criteria) this;
        }

        public Criteria andFTotalNhNotIn(List<BigDecimal> values) {
            addCriterion("f_total_nh not in", values, "fTotalNh");
            return (Criteria) this;
        }

        public Criteria andFTotalNhBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("f_total_nh between", value1, value2, "fTotalNh");
            return (Criteria) this;
        }

        public Criteria andFTotalNhNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("f_total_nh not between", value1, value2, "fTotalNh");
            return (Criteria) this;
        }

        public Criteria andFVoltageIsNull() {
            addCriterion("f_voltage is null");
            return (Criteria) this;
        }

        public Criteria andFVoltageIsNotNull() {
            addCriterion("f_voltage is not null");
            return (Criteria) this;
        }

        public Criteria andFVoltageEqualTo(BigDecimal value) {
            addCriterion("f_voltage =", value, "fVoltage");
            return (Criteria) this;
        }

        public Criteria andFVoltageNotEqualTo(BigDecimal value) {
            addCriterion("f_voltage <>", value, "fVoltage");
            return (Criteria) this;
        }

        public Criteria andFVoltageGreaterThan(BigDecimal value) {
            addCriterion("f_voltage >", value, "fVoltage");
            return (Criteria) this;
        }

        public Criteria andFVoltageGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("f_voltage >=", value, "fVoltage");
            return (Criteria) this;
        }

        public Criteria andFVoltageLessThan(BigDecimal value) {
            addCriterion("f_voltage <", value, "fVoltage");
            return (Criteria) this;
        }

        public Criteria andFVoltageLessThanOrEqualTo(BigDecimal value) {
            addCriterion("f_voltage <=", value, "fVoltage");
            return (Criteria) this;
        }

        public Criteria andFVoltageIn(List<BigDecimal> values) {
            addCriterion("f_voltage in", values, "fVoltage");
            return (Criteria) this;
        }

        public Criteria andFVoltageNotIn(List<BigDecimal> values) {
            addCriterion("f_voltage not in", values, "fVoltage");
            return (Criteria) this;
        }

        public Criteria andFVoltageBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("f_voltage between", value1, value2, "fVoltage");
            return (Criteria) this;
        }

        public Criteria andFVoltageNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("f_voltage not between", value1, value2, "fVoltage");
            return (Criteria) this;
        }

        public Criteria andFElectricIsNull() {
            addCriterion("f_electric is null");
            return (Criteria) this;
        }

        public Criteria andFElectricIsNotNull() {
            addCriterion("f_electric is not null");
            return (Criteria) this;
        }

        public Criteria andFElectricEqualTo(BigDecimal value) {
            addCriterion("f_electric =", value, "fElectric");
            return (Criteria) this;
        }

        public Criteria andFElectricNotEqualTo(BigDecimal value) {
            addCriterion("f_electric <>", value, "fElectric");
            return (Criteria) this;
        }

        public Criteria andFElectricGreaterThan(BigDecimal value) {
            addCriterion("f_electric >", value, "fElectric");
            return (Criteria) this;
        }

        public Criteria andFElectricGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("f_electric >=", value, "fElectric");
            return (Criteria) this;
        }

        public Criteria andFElectricLessThan(BigDecimal value) {
            addCriterion("f_electric <", value, "fElectric");
            return (Criteria) this;
        }

        public Criteria andFElectricLessThanOrEqualTo(BigDecimal value) {
            addCriterion("f_electric <=", value, "fElectric");
            return (Criteria) this;
        }

        public Criteria andFElectricIn(List<BigDecimal> values) {
            addCriterion("f_electric in", values, "fElectric");
            return (Criteria) this;
        }

        public Criteria andFElectricNotIn(List<BigDecimal> values) {
            addCriterion("f_electric not in", values, "fElectric");
            return (Criteria) this;
        }

        public Criteria andFElectricBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("f_electric between", value1, value2, "fElectric");
            return (Criteria) this;
        }

        public Criteria andFElectricNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("f_electric not between", value1, value2, "fElectric");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeIsNull() {
            addCriterion("v_update_time is null");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeIsNotNull() {
            addCriterion("v_update_time is not null");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeEqualTo(Date value) {
            addCriterion("v_update_time =", value, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeNotEqualTo(Date value) {
            addCriterion("v_update_time <>", value, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeGreaterThan(Date value) {
            addCriterion("v_update_time >", value, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("v_update_time >=", value, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeLessThan(Date value) {
            addCriterion("v_update_time <", value, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("v_update_time <=", value, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeIn(List<Date> values) {
            addCriterion("v_update_time in", values, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeNotIn(List<Date> values) {
            addCriterion("v_update_time not in", values, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("v_update_time between", value1, value2, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("v_update_time not between", value1, value2, "vUpdateTime");
            return (Criteria) this;
        }

        public Criteria andVremarkIsNull() {
            addCriterion("vRemark is null");
            return (Criteria) this;
        }

        public Criteria andVremarkIsNotNull() {
            addCriterion("vRemark is not null");
            return (Criteria) this;
        }

        public Criteria andVremarkEqualTo(String value) {
            addCriterion("vRemark =", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkNotEqualTo(String value) {
            addCriterion("vRemark <>", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkGreaterThan(String value) {
            addCriterion("vRemark >", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkGreaterThanOrEqualTo(String value) {
            addCriterion("vRemark >=", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkLessThan(String value) {
            addCriterion("vRemark <", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkLessThanOrEqualTo(String value) {
            addCriterion("vRemark <=", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkLike(String value) {
            addCriterion("vRemark like", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkNotLike(String value) {
            addCriterion("vRemark not like", value, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkIn(List<String> values) {
            addCriterion("vRemark in", values, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkNotIn(List<String> values) {
            addCriterion("vRemark not in", values, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkBetween(String value1, String value2) {
            addCriterion("vRemark between", value1, value2, "vremark");
            return (Criteria) this;
        }

        public Criteria andVremarkNotBetween(String value1, String value2) {
            addCriterion("vRemark not between", value1, value2, "vremark");
            return (Criteria) this;
        }

        public Criteria andTaskcodeIsNull() {
            addCriterion("taskCode is null");
            return (Criteria) this;
        }

        public Criteria andTaskcodeIsNotNull() {
            addCriterion("taskCode is not null");
            return (Criteria) this;
        }

        public Criteria andTaskcodeEqualTo(String value) {
            addCriterion("taskCode =", value, "taskcode");
            return (Criteria) this;
        }

        public Criteria andTaskcodeNotEqualTo(String value) {
            addCriterion("taskCode <>", value, "taskcode");
            return (Criteria) this;
        }

        public Criteria andTaskcodeGreaterThan(String value) {
            addCriterion("taskCode >", value, "taskcode");
            return (Criteria) this;
        }

        public Criteria andTaskcodeGreaterThanOrEqualTo(String value) {
            addCriterion("taskCode >=", value, "taskcode");
            return (Criteria) this;
        }

        public Criteria andTaskcodeLessThan(String value) {
            addCriterion("taskCode <", value, "taskcode");
            return (Criteria) this;
        }

        public Criteria andTaskcodeLessThanOrEqualTo(String value) {
            addCriterion("taskCode <=", value, "taskcode");
            return (Criteria) this;
        }

        public Criteria andTaskcodeLike(String value) {
            addCriterion("taskCode like", value, "taskcode");
            return (Criteria) this;
        }

        public Criteria andTaskcodeNotLike(String value) {
            addCriterion("taskCode not like", value, "taskcode");
            return (Criteria) this;
        }

        public Criteria andTaskcodeIn(List<String> values) {
            addCriterion("taskCode in", values, "taskcode");
            return (Criteria) this;
        }

        public Criteria andTaskcodeNotIn(List<String> values) {
            addCriterion("taskCode not in", values, "taskcode");
            return (Criteria) this;
        }

        public Criteria andTaskcodeBetween(String value1, String value2) {
            addCriterion("taskCode between", value1, value2, "taskcode");
            return (Criteria) this;
        }

        public Criteria andTaskcodeNotBetween(String value1, String value2) {
            addCriterion("taskCode not between", value1, value2, "taskcode");
            return (Criteria) this;
        }

        public Criteria andTypeIsNull() {
            addCriterion("type is null");
            return (Criteria) this;
        }

        public Criteria andTypeIsNotNull() {
            addCriterion("type is not null");
            return (Criteria) this;
        }

        public Criteria andTypeEqualTo(String value) {
            addCriterion("type =", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotEqualTo(String value) {
            addCriterion("type <>", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeGreaterThan(String value) {
            addCriterion("type >", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeGreaterThanOrEqualTo(String value) {
            addCriterion("type >=", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLessThan(String value) {
            addCriterion("type <", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLessThanOrEqualTo(String value) {
            addCriterion("type <=", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeLike(String value) {
            addCriterion("type like", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotLike(String value) {
            addCriterion("type not like", value, "type");
            return (Criteria) this;
        }

        public Criteria andTypeIn(List<String> values) {
            addCriterion("type in", values, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotIn(List<String> values) {
            addCriterion("type not in", values, "type");
            return (Criteria) this;
        }

        public Criteria andTypeBetween(String value1, String value2) {
            addCriterion("type between", value1, value2, "type");
            return (Criteria) this;
        }

        public Criteria andTypeNotBetween(String value1, String value2) {
            addCriterion("type not between", value1, value2, "type");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNull() {
            addCriterion("data_source is null");
            return (Criteria) this;
        }

        public Criteria andDataSourceIsNotNull() {
            addCriterion("data_source is not null");
            return (Criteria) this;
        }

        public Criteria andDataSourceEqualTo(String value) {
            addCriterion("data_source =", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotEqualTo(String value) {
            addCriterion("data_source <>", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThan(String value) {
            addCriterion("data_source >", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceGreaterThanOrEqualTo(String value) {
            addCriterion("data_source >=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThan(String value) {
            addCriterion("data_source <", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLessThanOrEqualTo(String value) {
            addCriterion("data_source <=", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceLike(String value) {
            addCriterion("data_source like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotLike(String value) {
            addCriterion("data_source not like", value, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceIn(List<String> values) {
            addCriterion("data_source in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotIn(List<String> values) {
            addCriterion("data_source not in", values, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceBetween(String value1, String value2) {
            addCriterion("data_source between", value1, value2, "dataSource");
            return (Criteria) this;
        }

        public Criteria andDataSourceNotBetween(String value1, String value2) {
            addCriterion("data_source not between", value1, value2, "dataSource");
            return (Criteria) this;
        }
    }

    /**
     * t_energy_history
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * t_energy_history 2019-03-12
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}